(function () {
    var Rally = function () {

        return {
            RallyWebAPI: function (jsonFile, callback) {
                require("dotenv").config();
                var logger = require("./Logger.js")
                var rallylog = require('./RallyLog.js');
                var fs = require("fs");
                var path = require('path');
                var Promise = require("bluebird");
                var RallyLogger = require("./RallyLogger.js");
                var RallyLoggerWeb = require("./RallyLoggerWeb.js");
                if (process.env.postToRally == undefined || process.env.postToRally == "false" || process.env.posttorally == "false" || process.env.PostToRally == "false") {
                    callback()
                } else {
                    for (var arg = 0; arg < process.argv.length; arg++) {
                        var temp1 = process.argv[arg].split("=");
                        if (temp1[0] == "--params") {
                            var param = process.argv[arg];
                            var args = param.split("=");
                            var indiv = args[1].split(",");
                            var apikey = indiv[0];
                            apikey = apikey.split(":")
                        }
                    }
                    var postToRally = process.env.postToRally;
                    if (postToRally == "true") {
                        logger.info("Executing Post To Rally - please wait\n");
                        console.log("Executing Post To Rally - please wait\n");
                        rallylog.info("Executing Post To Rally - please wait\n-------------------------------------------------\n");
                        var test_plan, test_plan_description, glb_folder_id, glb_i_length, testset, testset_env,
                            root_folder, root_folder_env,
                            project, project_env, ws;
                        if (process.env.rallyProxy != undefined) {
                            var proxy = process.env.rallyProxy
                        } else {
                            logger.info("No proxy defined - check .env file - No Results Posted");
                            console.log("No proxy defined - check .env file - No Results Posted");
                            rallylog.info("No proxy defined - check .env file - No Results Posted");
                            callback()
                        }

                        if (process.env.rallyworkspace != undefined) {
                            ws = process.env.rallyworkspace
                        } else {
                            ws = ""
                        }

                        if (process.env.project != undefined) {
                            project_env = process.env.project
                        } else {
                            project_env = ""
                        }

                        project = project_env

                        if (process.env.testset != undefined) {
                            testset_env = process.env.testset
                        } else {
                            testset_env = "";
                        }
                        testset = testset_env

                        if (process.env.rallyrootfolder != undefined) {
                            root_folder_env = process.env.rallyrootfolder
                        } else {
                            root_folder_env = "";
                        }
                        root_folder = root_folder_env

                        var zsessionid = undefined;
                        if (apikey != undefined) {
                            zsessionid = apikey[1]
                        } else if (apikey == undefined && process.env.apiKey != undefined) {
                            zsessionid = process.env.apiKey
                        } else {
                            logger.info("No apiKey provided - check .env file or command line parameter - No Results Posted");
                            console.log("No apiKey provided - check .env file or command line parameter - No Results Posted");
                            rallylog.info("No apiKey provided - check .env file or command line parameter - No Results Posted");
                            callback()
                        }
                        if (zsessionid != undefined && proxy != undefined) {
                            var baseUrl = "https://rally1.rallydev.com/slm/webservice/v2.0/";
                            var json;
                            fs.readFile(path.resolve(__dirname, jsonFile), "UTF-8", function (err, data) {
                                    if (err) {
                                        rallylog.info("Did not find rally json file\nError: "+err)
                                        console.log("error: " + err)
                                    } else {
                                        var RallyMethodsWeb = require("./RallyMethodsWeb.js");
                                        json = JSON.parse(data);
                                        var found = false;
                                        var i, j, k;

                                        function queryTF(testfolder, test_plan, project, ws, rootfolder, callbck) {
                                            return new Promise(function (resolve, reject) {
                                                RallyLoggerWeb.getObjectRef(testfolder, test_plan, project, ws, rootfolder, resolve)
                                            })
                                        }

                                        function createTP(test_plan, ws, proj, rootid, callbck) {
                                            return new Promise(function (resolve, reject) {
                                                RallyLoggerWeb.createTestPlan(test_plan, ws, proj, rootid, resolve)
                                            })
                                        }

                                        function updateTP(name, ws, proj, rootid, curfolderid, callbck) {
                                            return new Promise(function (resolve, reject) {
                                                RallyLoggerWeb.updateTestPlan(name, ws, proj, rootid, curfolderid, resolve)
                                            })
                                        }

                                        var step = function (i, done) {
                                            if (i < json.length) {
                                                var loop = function (i, done) {
                                                    glb_i_length = json.length; // This length determines the number of features
                                                    test_plan = json[i].name; // Name of feature
                                                    test_plan_description = json[i].description;
                                                    var tp_temp = test_plan.split(":");

                                                    // Resetting variables to env
                                                    testset = testset_env;
                                                    project = project_env;
                                                    root_folder = root_folder_env;

                                                    // Parsing the Feature name to see if there is a testset, rootfolder, or project name
                                                    var step2 = function (j, done) {
                                                        if (j < done) {

                                                            // Check if it is testset. If overwrite_TS is false, then use the testset from feature file
                                                            if (tp_temp[j] != undefined && tp_temp[j].trim().startsWith("TS")) {
                                                                if (process.env.overwrite_TS == "false" || process.env.overwrite_TS == undefined)
                                                                    testset = tp_temp[j].trim();
                                                                step2(j + 1, done)
                                                            }
                                                            // Check if it is rootfolder. If overwrite_RF is false, then use the rootfolder from feature file

                                                            if (tp_temp[j] != undefined && tp_temp[j].trim().startsWith("RF-")) {
                                                                if (process.env.overwrite_RF == "false" || process.env.overwrite_RF == undefined) {
                                                                    root_folder = tp_temp[j].trim().substring(3);
                                                                }
                                                                // console.log("Step2 test3")
                                                                step2(j + 1, done)
                                                            }
                                                            // Check if it is project. If overwrite_PN is false, then use the project from feature file
                                                            if (tp_temp[j] != undefined && tp_temp[j].trim().startsWith("PN-")) {
                                                                if (process.env.overwrite_PN == "false" || process.env.overwrite_PN == undefined)
                                                                    project = tp_temp[j].trim().substring(3);
                                                                // console.log("Step2 test4")
                                                                step2(j + 1, done)
                                                            }


                                                        }

                                                    }
                                                    // console.log("Step2 test1")
                                                    step2(0, tp_temp.length)
                                                    test_plan = tp_temp[tp_temp.length - 1].trim() // This is the final test plan name after the test plan is parsed


                                                    RallyLoggerWeb.UserPermissions("workspace", ws, function (resp) {
                                                        if (resp == "NOT_FOUND") {
                                                            console.log("Workspace NOT FOUND - possible reasons: \n" + "1. You do not have permission/access to the workspace\n" + "2. The Workspace has been spelled incorrectly");
                                                            logger.info("Workspace NOT FOUND - possible reasons: \n" + "1. You do not have permission/access to that workspace\n" + "2. The Workspace has been spelled incorrectly");
                                                            rallylog.info("Workspace NOT FOUND - possible reasons: \n" + "1. You do not have permission/access to that workspace\n" + "2. The Workspace has been spelled incorrectly");
                                                            callback()
                                                        }
                                                        else if (resp.errors != null) {
                                                            callback();
                                                        }
                                                        else {
                                                            var workspace = resp.wsRef;
                                                            var wsProject ={
                                                                workspace: ws,
                                                                project: project
                                                            };
                                                            RallyLoggerWeb.UserPermissions("project", wsProject, function (resp) {
                                                                if (resp == "NOT_FOUND") {
                                                                    console.log("Project NOT FOUND - possible reasons: \n" + "1. You do not have permission/access to the project\n" + "2. The Project has been spelled incorrectly");
                                                                    logger.info("Project NOT FOUND - possible reasons: \n" + "1. You do not have permission/access to that project\n" + "2. The Project has been spelled incorrectly");
                                                                    rallylog.info("Project NOT FOUND - possible reasons: \n" + "1. You do not have permission/access to that project\n" + "2. The Project has been spelled incorrectly");
                                                                    callback()
                                                                }
                                                                else if (resp.errors != null) {
                                                                    callback();
                                                                }
                                                                else {
                                                                    var proj = resp.projRef;

                                                                    //This is when the rootfolder is defined from either the env or feature file
                                                                    var root_path_arr = root_folder.split("\\");

                                                                    var previous_folderid = new Array;

                                                                    var stepCreaterootfolder = function (m, done) {
                                                                        var tempParentfolder = "";
                                                                        if (m > 0) {
                                                                            tempParentfolder = previous_folderid.pop()
                                                                        }
                                                                        if (m < root_path_arr.length) {
                                                                            if(root_path_arr[m].trim() != "") {
                                                                                queryTF("testfolder", root_path_arr[m].trim(), proj, workspace, tempParentfolder).then(function (root_response) {
                                                                                    if (root_response != "NOT_FOUND") {
                                                                                        if (m > 0) {
                                                                                            updateTP(root_path_arr[m].trim(), workspace, proj, tempParentfolder, root_response.id).then(function (response) {
                                                                                                previous_folderid.push(response.id);
                                                                                                stepCreaterootfolder(m + 1)
                                                                                            })
                                                                                        } else {
                                                                                            previous_folderid.push(root_response.id);
                                                                                            stepCreaterootfolder(m + 1)
                                                                                        }
                                                                                    } else {
                                                                                        createTP(root_path_arr[m].trim(), workspace, proj, tempParentfolder).then(function (resp) {
                                                                                            previous_folderid.push(resp.id);
                                                                                            stepCreaterootfolder(m + 1)
                                                                                        })
                                                                                    }
                                                                                })
                                                                            }else{
                                                                                stepCreaterootfolder(m + 1)
                                                                            }

                                                                        }
                                                                        else {
                                                                            var root_folderid = tempParentfolder;
                                                                            queryTF("testfolder", test_plan, proj, workspace, root_folderid).then(function (response) {
                                                                                var tpObj = {
                                                                                    testset: testset,
                                                                                    glb_i_length: glb_i_length,
                                                                                    ws: workspace,
                                                                                    proj: proj,
                                                                                    rootfolderid: root_folderid,
                                                                                    // tags: tags
                                                                                };
                                                                                if (response != "NOT_FOUND") {
                                                                                    glb_folder_id = response.id;
                                                                                    updateTP(test_plan, workspace, proj, root_folderid, glb_folder_id).then(function (response) {
                                                                                        response.json = json;
                                                                                        response.i = i;
                                                                                        // console.log("test1 "+JSON.stringify(json[i]) )
                                                                                        // console.log("test2 "+ JSON.stringify(response.json[response.i]) )

                                                                                        RallyMethodsWeb.TestFolderFound(tpObj, response, function (resp) {
                                                                                            if (resp == "step i") step(i + 1, done); else if (resp == "callback") {
                                                                                                callback()
                                                                                            }
                                                                                        })
                                                                                    })
                                                                                } else {
                                                                                    rallylog.info("Create test plan: " + test_plan + "\n");
                                                                                    response = {
                                                                                        json: json,
                                                                                        i: i,
                                                                                        test_plan: test_plan
                                                                                    };
                                                                                    tpObj.ws = workspace;
                                                                                    tpObj.proj = proj;
                                                                                    RallyMethodsWeb.noTestFolderFound(tpObj, response, function (resp) {
                                                                                        if (resp == "step i") step(i + 1, done); else if (resp == "callback") {
                                                                                            callback()
                                                                                        }
                                                                                    })
                                                                                }
                                                                            })
                                                                        }
                                                                    };
                                                                    stepCreaterootfolder(0)

                                                                }
                                                            })
                                                        }
                                                    })
                                                };
                                                loop(i, done)
                                            }
                                        };
                                        step(0)
                                    }
                                }
                            )
                        }
                    }
                }
            }
        }
    };
    module.exports = new Rally
})();