(function () {
    var logger = require("./Logger.js");
    var request = require("request-promise").defaults({ jar: true });
    var RallyLoggerWeb = require("./RallyLoggerWeb.js");
    require("dotenv").config();
    var build_num, postOnlyTS;
    if (process.env.build_no != undefined) build_num = process.env.build_no; else build_num = 1;
    var name, status, duration, keyword, description, glb_test_case_id, glb_test_result_id, test_case_name,
        test_case_description, line, glb_j_length, glb_k_length, User_Story="", User_Story_env, TestCase_Number, json, i,
        error_message = "", temp_error_message = ""; temp_errormsg = "";
    var stepsArray = [];
    var RallyMethodsWeb = function () {
        var stat;
        var duration1;

        function queryUSTS(USTS, ws, proj, type, callbck) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.getUSTSRef(USTS, ws, proj, type, resolve)
            })
        }

        function queryRH(type, obj, callbck) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.UserPermissions(type, obj, resolve)
            })
        }

        function queryTC(type, test_case_name, project, ws, testfolder, callbck) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.getObjectRef(type, test_case_name, project, ws, testfolder, resolve)
            })
        }

        function createTC(opts, ws, proj, callbck_create) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.createTestcase(opts, ws, proj, resolve)
            })
        }

        function createTCR(opts, ws, proj, callbck) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.createTestcaseResult(opts, ws, proj, resolve)
            })
        }

        function createTP(test_plan, ws, proj, rootid, callbck) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.createTestPlan(test_plan, ws, proj, rootid, resolve)
            })
        }

        function createTPwithRootfolder(test_plan, ws, proj, parentobjectid, callbck) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.createTestPlanWithRootFolder(test_plan, ws, proj, rootfolder, resolve)
            })
        }

        function updateTS(tcObj, resp, callbck) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.updateTestSet(tcObj, resp, resolve)
            })
        }

        function updateTC(obj, ws, proj, callbck) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.updateTestCase(obj, ws, proj, resolve)
            })
        }

        function getTagID(ws, proj, tags, callbck) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.getTagId(ws, proj, tags, resolve)
            })
        }

        function setTag(obj, ws, proj, callbck) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.setTagId(obj, ws, proj, resolve)
            })
        }

        function TCR(tcObj, resp, callback) {
            return new Promise(function (resolve, reject) {
                require("./RallyMethodsWeb.js").TestCaseResult(tcObj, resp, resolve)
            })
        }

        function updateTCR(tcObj, resp, callbck) {
            return new Promise(function (resolve, reject) {
                RallyLoggerWeb.updateTestCaseResult(tcObj, resp, resolve)
            })
        }

        function kloop(resp, callbck) {
            return new Promise(function (resolve, reject) {
                k_loop(resp, resolve)
            })
        }

        var k_loop = function (resp, callbck) {
            duration1 = 0;
            stepsArray = [];
            var failure = false;
            var statUndefined = false;
            for (k = 0; k < resp.resp.json[resp.i].elements[resp.j].steps.length; k++) {
                // console.log("K: " + k)
                glb_k_length = resp.resp.json[resp.i].elements[resp.j].steps.length;
                if (resp.resp.json[resp.i].elements[resp.j].steps[k].result.duration != undefined && resp.resp.json[resp.i].elements[resp.j].steps[k].result.duration != "undefined") {
                    duration1 = duration1 + resp.resp.json[resp.i].elements[resp.j].steps[k].result.duration
                } else {
                    duration1 = duration1 + 0
                }
                keyword = resp.resp.json[resp.i].elements[resp.j].steps[k].keyword;
                if (resp.resp.json[resp.i].elements[resp.j].description != undefined) {
                    description = resp.resp.json[resp.i].elements[resp.j].description
                } else {
                    description = ""
                }
                if (k < resp.resp.json[resp.i].elements[resp.j].steps.length - 1) {
                    if (resp.resp.json[resp.i].elements[resp.j].steps[k].result.error_message != undefined && resp.resp.json[resp.i].elements[resp.j].steps[k].keyword.trim() != "After") {
                        temp_error_message = JSON.stringify(resp.resp.json[resp.i].elements[resp.j].steps[k].result.error_message);
                        error_message = temp_error_message.substring(1, temp_error_message.length - 1)
                        temp_errormsg += error_message;
                    } else if(resp.resp.json[resp.i].elements[resp.j].steps[k].keyword.trim() == "After" && resp.resp.json[resp.i].elements[resp.j].steps[k].result.status == "failed"){
                        error_message = error_message +"<br> <br>"+ 'After Hook error message : '+ "<br>"+JSON.stringify(resp.resp.json[resp.i].elements[resp.j].steps[k].result.error_message).substring(1,JSON.stringify(resp.resp.json[resp.i].elements[resp.j].steps[k].result.error_message).length-1);
                    }
                    else {
                        if (temp_errormsg=="" && resp.resp.json[resp.i].elements[resp.j].steps[k].result.status == "passed") {
                            error_message = ""
                        }
                    }
                }
                if (resp.resp.json[resp.i].elements[resp.j].steps[k].match != undefined) line = resp.resp.json[resp.i].elements[resp.j].steps[k].match.location; else line = 0;
                if (resp.resp.json[resp.i].elements[resp.j].steps[k].keyword.trim() != "Before" && resp.resp.json[resp.i].elements[resp.j].steps[k].keyword.trim() != "After") {
                    name = resp.resp.json[resp.i].elements[resp.j].steps[k].name;
                    if (name != undefined) {
                        stepsArray.push("<br>" + parseInt(k + 1) + ". " + name)
                    } else {
                        break
                    }
                }
                if (resp.resp.json[resp.i].elements[resp.j].steps[k].result.status == undefined || resp.resp.json[resp.i].elements[resp.j].steps[k].result.status == "undefined") {
                    statUndefined = true
                } else {
                    stat = resp.resp.json[resp.i].elements[resp.j].steps[k].result.status;
                    if (stat == "failed") {
                        failure = true
                    }
                }
            }
            // console.log("Before the length -1. K: " + k)
            // console.log("Before the length -1. length: " + resp.resp.json[resp.i].elements[resp.j].steps.length)
            if (k == resp.resp.json[resp.i].elements[resp.j].steps.length) {
                // console.log("Inisde the length -1")
                if (k == 0) {
                    duration1 = (duration1 / 1e9).toFixed(2);
                    if (failure) {
                        stat = "failed"
                    } else if (statUndefined) {
                        stat = undefined
                    }
                } else {
                    duration1 = (duration1 / k / 1e9).toFixed(2);
                    if (failure) {
                        stat = "failed"
                    } else if (statUndefined) stat = undefined
                }
                return callbck(resp)
            }
        };

        var test_case_array = [];


        return {
            TestCaseFound: function (tcObj, callback) {
                var owner_url = tcObj.resp.revision_history_ref;
                var duration, status;
                queryRH("", "").then(function (resp) {
                    var owner = resp.owner_id;
                    kloop(tcObj).then(function (response) {
                        tcObj.stepsArray = stepsArray;

                        queryUSTS(tcObj.User_Story, tcObj.ws, tcObj.proj, "hierarchicalrequirement").then(function (resp) {
                            updateTC({
                                resp: resp,
                                owner: owner,
                                tcObj: tcObj,
                                error: error_message
                            }, tcObj.ws, tcObj.proj).then(function (resp) {
                                queryUSTS(tcObj.testset, tcObj.ws, tcObj.proj, "testset").then(function (resp) {
                                    resp.status = stat;
                                    resp.duration = duration1;
                                    resp.i = i;
                                    resp.j = tcObj.j;
                                    resp.json = json;
                                    updateTS(tcObj, resp).then(function (resp) {
                                        //console.log("The tag in methods is: "+tcObj.tags)
                                        if (process.env.tag != null && process.env.tag != "" && typeof process.env.tag != "undefined") {
                                            tcObj.tags = process.env.tag;
                                        }

                                        else if (tcObj.tags != null && tcObj.tags != "") {
                                            tcObj.tags = tcObj.tags;
                                        }
                                        else
                                            tcObj.tags = null;

                                        if (tcObj.tags != null) {
                                            getTagID(tcObj.ws, tcObj.proj, tcObj.tags).then(function (tagIDResponse) {
                                                tcObj.tagId = tagIDResponse.tagID;
                                                if (tcObj.tagId != "" && tcObj.tagId != undefined && typeof(tcObj.tagId) != "undefined") {
                                                    setTag(tcObj, tcObj.ws, tcObj.proj).then(function () {
                                                        TCR(tcObj, resp).then(function (resp) {
                                                            if (resp == "step i")return callback("step i"); else if (resp == "step j")return callback("step j"); else return callback("callback")
                                                        }).catch(function (error) {
                                                            callback("callback")
                                                        });
                                                    })
                                                }
                                                else {
                                                    TCR(tcObj, resp).then(function (resp) {
                                                        if (resp == "step i")return callback("step i"); else if (resp == "step j")return callback("step j"); else return callback("callback")
                                                    }).catch(function (error) {
                                                        callback("callback")
                                                    });
                                                }
                                            }).catch(function (error) {
                                                callback("callback")
                                            });
                                        }
                                        else {
                                            TCR(tcObj, resp).then(function (resp) {
                                                if (resp == "step i")return callback("step i"); else if (resp == "step j")return callback("step j"); else return callback("callback")
                                            }).catch(function (error) {
                                                callback("callback")
                                            });
                                        }
                                    }).catch(function (error) {
                                        callback("callback")
                                    })
                                }).catch(function (error) {
                                    callback("callback")
                                })
                            }).catch(function (error) {
                                callback("callback")
                            })
                        }).catch(function (error) {
                            console.log("error is: "+error)
                            callback("callback")
                        })
                    }).catch(function (error) {
                        callback("callback")
                    })
                }).catch(function (error) {
                    console.log("error was: "+error);
                    callback("callback")
                })
            },

            noTestCaseFound: function (tcObj, kObj, callback) {

                queryUSTS(tcObj.User_Story, tcObj.ws, tcObj.proj, "hierarchicalrequirement").then(function (resp) {
                    tcObj.User_Story = resp.id;
                    queryRH("", "").then(function (resp) {
                        tcObj.owner = resp.owner_id;
                        var obj = {tcObj: tcObj, kObj: kObj, error: error_message};
                        createTC(obj, tcObj.ws, tcObj.proj).then(function (response) {
                            glb_test_case_id = response.id;
                            response.json = json;
                            response.i = i;
                            response.j = tcObj.j;
                            response.duration = kObj.duration;
                            response.status = kObj.status;
                            tcObj.glb_test_case_id = response.id;
                            queryUSTS(tcObj.testset, tcObj.ws, tcObj.proj, "testset").then(function (resp) {
                                resp.status = stat;
                                resp.duration = duration1;
                                resp.i = i;
                                resp.j = tcObj.j;
                                resp.json = json;
                                updateTS(tcObj, resp).then(function (response) {
                                    tcObj.last_run = false;
                                    var RallyMethodsWeb = require("./RallyMethodsWeb.js");

                                    //Setting the tags based on env first. If tag in env file is null, it will grab it from the feature file which was set earlier
                                    if (process.env.tag != null && process.env.tag != "" && typeof process.env.tag != "undefined") {
                                        tcObj.tags = process.env.tag;
                                    }
                                    else if (tcObj.tags != null && tcObj.tags != "") {
                                        tcObj.tags = tcObj.tags;
                                    }
                                    else
                                        tcObj.tags = null;

                                    if (tcObj.tags != null) {
                                        getTagID(tcObj.ws, tcObj.proj, tcObj.tags).then(function (tagIDResponse) {
                                            tcObj.tagId = tagIDResponse.tagID;
                                            if (tcObj.tagId != "" && tcObj.tagId != undefined && typeof(tcObj.tagId) != "undefined") {
                                                setTag(tcObj, tcObj.ws, tcObj.proj).then(function () {
                                                    TCR(tcObj, resp).then(function (resp) {
                                                        if (resp == "step i")return callback("step i"); else if (resp == "step j")return callback("step j"); else return callback("callback")
                                                    });
                                                }).catch(function (error) {
                                                    callback("callback")
                                                });
                                            }
                                            else {
                                                TCR(tcObj, resp).then(function (resp) {
                                                    if (resp == "step i")return callback("step i"); else if (resp == "step j")return callback("step j"); else return callback("callback")
                                                }).catch(function (error) {
                                                    callback("callback")
                                                });
                                            }
                                        }).catch(function (error) {
                                            callback("callback")
                                        });
                                    }
                                    else {
                                        // console.log("Inside TCR");
                                        TCR(tcObj, resp).then(function (resp) {
                                            if (resp == "step i")return callback("step i"); else if (resp == "step j")return callback("step j"); else return callback("callback")
                                        }).catch(function (error) {
                                            callback("callback")
                                        });
                                    }
                                }).catch(function (error) {
                                    callback("callback")
                                })
                            }).catch(function (error) {
                                callback("callback")
                            })
                        }).catch(function (error) {
                            callback("callback")
                        })
                    })
                }).catch(function (error) {
                    callback("callback")
                })
            },

            TestFolderFound: function (tpObj, response, callback) {
                
                json = response.json;
                i = response.i;
                glb_folder_id = response.id;
                var step2 = function (j, done) {
                    TestCase_Number = "";
                    // Grabbing the user stories and TC numbers from the feature files
                    if (j < json[i].elements.length) {
                        glb_j_length = json[i].elements.length;
                        test_case_name = json[i].elements[j].name.replace(/\s+\s/i, '');
                        temp = test_case_name.split(":");

                        if (temp[2] != undefined) {
                            test_case_name = temp[2]
                            if (temp[0].match(/US[0-9]+/)) {
                                User_Story = temp[0];
                                TestCase_Number = temp[1];
                            }
                            else {
                                User_Story = temp[1];
                                TestCase_Number = temp[0];
                            }
                        }

                        else if (temp[1] != undefined) {
                            if (temp[0].match(/US[0-9]+/)) {
                                User_Story = temp[0];
                                User_Story = User_Story.trim();
                            }
                            else {
                                TestCase_Number = temp[0];
                            }
                            test_case_name = temp[1]
                        }

                        else {
                            User_Story = "";
                        }

                        test_case_name = test_case_name.trim();
                        test_case_description = json[i].elements[j].description;
                        var test_case_line = json[i].elements[j].line;

                        //Grabbing tags from test cases

                        if (typeof json[i].elements[j].tags != "undefined" && json[i].elements[j].tags != null && json[i].elements[j].tags.length > 0) {

                            if (json[i].elements[j].tags[0].name != null && typeof json[i].elements[j].tags[0].name != "undefined") {
                                tags = json[i].elements[j].tags[0].name;
                                tags = tags.replace(/@/g, "");
                                tpObj.tags = tags;
                            }
                        }
                        else {
                            tpObj.tags = null;
                        }


                        var loop2 = function (j, done) {
                            var temp = 0;
                            if (TestCase_Number != null && TestCase_Number != "" && TestCase_Number != undefined && TestCase_Number!="undefined") {
                                queryUSTS(TestCase_Number, tpObj.ws, tpObj.proj, "testcase").then(function (resp) {
                                    // queryTC("testcase", test_case_name, tpObj.proj, tpObj.ws, glb_folder_id).then(function (resp) {
                                    glb_test_case_id = resp.id;
                                    var last_run = resp.last_run;
                                    glb_test_result_id = resp.test_case_result_id;
                                    if (resp != "NOT_FOUND" && resp.id!="") {
                                        resp.json = json;
                                        resp.i = i;
                                        resp.j = j;
                                        var tcObj = {
                                            User_Story: User_Story,
                                            resp: resp,
                                            j: j,
                                            test_case_name: test_case_name,
                                            test_case_description: test_case_description,
                                            glb_folder_id: glb_folder_id,
                                            build_num: build_num,
                                            testset: tpObj.testset,
                                            glb_test_case_id: glb_test_case_id,
                                            glb_test_result_id: glb_test_result_id,
                                            last_run: last_run,
                                            glb_i_length: tpObj.glb_i_length,
                                            glb_j_length: glb_j_length,
                                            i: i,
                                            ws: tpObj.ws,
                                            proj: tpObj.proj,
                                            tags: tpObj.tags,
                                            testset_defined_env: tpObj.testset_defined_env,
                                            stepsArray: stepsArray
                                        };
                                        require("./RallyMethodsWeb.js").TestCaseFound(tcObj, function (response) {
                                            if (response == "step i") callback("step i"); else if (response == "step j") step2(j + 1, done); else callback("callback")
                                        })
                                    } else {
                                        resp = {json: json, i: i, j: j};
                                        var tcObj = {
                                            User_Story: User_Story,
                                            resp: resp,
                                            j: j,
                                            test_case_name: test_case_name,
                                            test_case_description: test_case_description,
                                            glb_folder_id: glb_folder_id,
                                            build_num: build_num,
                                            testset: tpObj.testset,
                                            glb_test_case_id: glb_test_case_id,
                                            glb_test_result_id: glb_test_result_id,
                                            last_run: last_run,
                                            glb_i_length: tpObj.glb_i_length,
                                            glb_j_length: glb_j_length,
                                            i: i,
                                            ws: tpObj.ws,
                                            proj: tpObj.proj,
                                            tags: tpObj.tags,
                                            testset_defined_env: tpObj.testset_defined_env
                                        };
                                        kloop(tcObj).then(function (response) {
                                            var kObj = {
                                                duration: duration,
                                                status: stat,
                                                response: response,
                                                stepsArray: stepsArray
                                            };
                                            tcObj.stepsArray = stepsArray;
                                            require("./RallyMethodsWeb.js").noTestCaseFound(tcObj, kObj, function (response) {
                                                if (response == "step i") callback("step i"); else if (response == "step j") step2(j + 1, done); else callback("callback")
                                            })
                                        })
                                    }
                                }).catch(function (error) {
                                    console.log("error: " + error);
                                    callback()
                                })
                            }
                            else {
                                queryTC("testcase", test_case_name, tpObj.proj, tpObj.ws, glb_folder_id).then(function (resp) {
                                    glb_test_case_id = resp.id;
                                    var last_run = resp.last_run;
                                    glb_test_result_id = resp.test_case_result_id;
                                    if (resp != "NOT_FOUND") {
                                        resp.json = json;
                                        resp.i = i;
                                        resp.j = j;
                                        var tcObj = {
                                            User_Story: User_Story,
                                            resp: resp,
                                            j: j,
                                            test_case_name: test_case_name,
                                            test_case_description: test_case_description,
                                            glb_folder_id: glb_folder_id,
                                            build_num: build_num,
                                            testset: tpObj.testset,
                                            glb_test_case_id: glb_test_case_id,
                                            glb_test_result_id: glb_test_result_id,
                                            last_run: last_run,
                                            glb_i_length: tpObj.glb_i_length,
                                            glb_j_length: glb_j_length,
                                            i: i,
                                            ws: tpObj.ws,
                                            proj: tpObj.proj,
                                            tags: tpObj.tags,
                                            testset_defined_env: tpObj.testset_defined_env,
                                            stepsArray: stepsArray
                                        };
                                        require("./RallyMethodsWeb.js").TestCaseFound(tcObj, function (response) {
                                            if (response == "step i") callback("step i"); else if (response == "step j") step2(j + 1, done); else callback("callback")
                                        })
                                    } else {
                                        resp = {json: json, i: i, j: j};
                                        var tcObj = {
                                            User_Story: User_Story,
                                            resp: resp,
                                            j: j,
                                            test_case_name: test_case_name,
                                            test_case_description: test_case_description,
                                            glb_folder_id: glb_folder_id,
                                            build_num: build_num,
                                            testset: tpObj.testset,
                                            glb_test_case_id: glb_test_case_id,
                                            glb_test_result_id: glb_test_result_id,
                                            last_run: last_run,
                                            glb_i_length: tpObj.glb_i_length,
                                            glb_j_length: glb_j_length,
                                            i: i,
                                            ws: tpObj.ws,
                                            proj: tpObj.proj,
                                            tags: tpObj.tags,
                                            testset_defined_env: tpObj.testset_defined_env
                                        };
                                        kloop(tcObj).then(function (response) {
                                            var kObj = {
                                                duration: duration,
                                                status: stat,
                                                response: response,
                                                stepsArray: stepsArray
                                            };
                                            tcObj.stepsArray = stepsArray;
                                            require("./RallyMethodsWeb.js").noTestCaseFound(tcObj, kObj, function (response) {
                                                if (response == "step i") callback("step i"); else if (response == "step j") step2(j + 1, done); else callback("callback")
                                            })
                                        })
                                    }
                                }).catch(function (error) {
                                    console.log("error: " + error);
                                    callback()
                                })
                            }
                        };
                        loop2(j, done)
                    }
                };
                step2(0)
            },

            noTestFolderFound: function (tpObj, response, callback) {
                var tagNoTestFolder;
                json = response.json;
                i = response.i;
                var test_plan = response.test_plan;
                var test_plan_description = json[i].description;
                createTP(test_plan, tpObj.ws, tpObj.proj, tpObj.rootfolderid).then(function (resp) {

                    var step3 = function (j, done) {
                        TestCase_Number = "";
                        // Grabbing the user stories and TC numbers from the feature files
                        if (j < json[i].elements.length) {
                            glb_j_length = json[i].elements.length;
                            glb_folder_id = resp.id;
                            test_case_name = json[i].elements[j].name.replace(/\s+\s/i, '');
                            temp = test_case_name.split(":");

                            if (temp[2] != undefined) {
                                test_case_name = temp[2]
                                if (temp[0].match(/US[0-9]+/)) {
                                    User_Story = temp[0];
                                    TestCase_Number = temp[1];
                                }
                                else {
                                    User_Story = temp[1];
                                    TestCase_Number = temp[0];
                                }
                            }

                            else if (temp[1] != undefined) {
                                if (temp[0].match(/US[0-9]+/)) {
                                    User_Story = temp[0];
                                    User_Story = User_Story.trim();
                                }
                                else {
                                    TestCase_Number = temp[0];
                                }
                                test_case_name = temp[1]
                            }

                            else {
                                User_Story = "";
                            }

                            test_case_name = test_case_name.trim();
                            test_case_description = json[i].elements[j].description;
                            var test_case_line = json[i].elements[j].line;

                            //Grabbing tags from feature files

                            if (typeof json[i].elements[j].tags != "undefined" && json[i].elements[j].tags.length > 0) {
                                //
                                if (json[i].elements[j].tags[0].name != null && typeof json[i].elements[j].tags[0].name != "undefined") {
                                    tagNoTestFolder = json[i].elements[j].tags[0].name;
                                    tagNoTestFolder = tagNoTestFolder.replace(/@/g, "");
                                }
                            }
                            else {
                                tagNoTestFolder = null;
                            }


                            var loop3 = function (j, done) {

                                if (TestCase_Number != null && TestCase_Number != "" && TestCase_Number != undefined && TestCase_Number!="undefined") {
                                    queryUSTS(TestCase_Number, tpObj.ws, tpObj.proj, "testcase").then(function (resp) {
                                        glb_test_case_id = resp.id;
                                        var last_run = resp.last_run;
                                        glb_test_result_id = resp.test_case_result_id;
                                        if (resp != "NOT_FOUND" && resp.id!="") {
                                            resp.json = json;
                                            resp.i = i;
                                            resp.j = j;
                                            var tcObj = {
                                                User_Story: User_Story,
                                                resp: resp,
                                                j: j,
                                                test_case_name: test_case_name,
                                                test_case_description: test_case_description,
                                                glb_folder_id: glb_folder_id,
                                                build_num: build_num,
                                                testset: tpObj.testset,
                                                glb_test_case_id: glb_test_case_id,
                                                glb_test_result_id: glb_test_result_id,
                                                last_run: last_run,
                                                glb_i_length: tpObj.glb_i_length,
                                                glb_j_length: glb_j_length,
                                                i: i,
                                                ws: tpObj.ws,
                                                proj: tpObj.proj,
                                                tags: tagNoTestFolder,
                                                testset_defined_env: tpObj.testset_defined_env,
                                                stepsArray: stepsArray
                                            };
                                            require("./RallyMethodsWeb.js").TestCaseFound(tcObj, function (response) {
                                                if (response == "step i") callback("step i"); else if (response == "step j") step3(j + 1, done); else callback("callback")
                                            })
                                        } else {
                                            resp = {json: json, i: i, j: j};
                                            var tcObj = {
                                                User_Story: User_Story,
                                                resp: resp,
                                                j: j,
                                                test_case_name: test_case_name,
                                                test_case_description: test_case_description,
                                                glb_folder_id: glb_folder_id,
                                                build_num: build_num,
                                                testset: tpObj.testset,
                                                glb_test_case_id: glb_test_case_id,
                                                glb_test_result_id: glb_test_result_id,
                                                last_run: last_run,
                                                glb_i_length: tpObj.glb_i_length,
                                                glb_j_length: glb_j_length,
                                                i: i,
                                                ws: tpObj.ws,
                                                proj: tpObj.proj,
                                                tags: tagNoTestFolder,
                                                testset_defined_env: tpObj.testset_defined_env
                                            };
                                            kloop(tcObj).then(function (resp1) {
                                                tcObj.stepsArray = stepsArray;
                                                var RallyMethodsWeb = require("./RallyMethodsWeb.js");
                                                var kObj = {
                                                    duration: duration1,
                                                    status: stat,
                                                    response: resp1,
                                                    stepsArray: stepsArray
                                                };
                                                RallyMethodsWeb.noTestCaseFound(tcObj, kObj, function (response) {
                                                    if (response == "step i") callback("step i"); else if (response == "step j") step3(j + 1, done); else callback("callback")
                                                })
                                            })
                                        }
                                    }).catch(function (error) {
                                        console.log("error: " + error);
                                        callback()
                                    })
                                }
                                else {
                                    queryTC("testcase", test_case_name, tpObj.proj, tpObj.ws, glb_folder_id).then(function (resp) {
                                        glb_test_case_id = resp.id;
                                        var last_run = resp.last_run;
                                        glb_test_result_id = resp.test_case_result_id;
                                        if (resp != "NOT_FOUND") {
                                            resp.json = json;
                                            resp.i = i;
                                            resp.j = j;
                                            var tcObj = {
                                                User_Story: User_Story,
                                                resp: resp,
                                                j: j,
                                                test_case_name: test_case_name,
                                                test_case_description: test_case_description,
                                                glb_folder_id: glb_folder_id,
                                                build_num: build_num,
                                                testset: tpObj.testset,
                                                glb_test_case_id: glb_test_case_id,
                                                glb_test_result_id: glb_test_result_id,
                                                last_run: last_run,
                                                glb_i_length: tpObj.glb_i_length,
                                                glb_j_length: glb_j_length,
                                                i: i,
                                                ws: tpObj.ws,
                                                proj: tpObj.proj,
                                                tags: tagNoTestFolder,
                                                testset_defined_env: tpObj.testset_defined_env,
                                                stepsArray: stepsArray
                                            };
                                            require("./RallyMethodsWeb.js").TestCaseFound(tcObj, function (response) {
                                                if (response == "step i") callback("step i"); else if (response == "step j") step3(j + 1, done); else callback("callback")
                                            })
                                        } else {
                                            resp = {json: json, i: i, j: j};
                                            var tcObj = {
                                                User_Story: User_Story,
                                                resp: resp,
                                                j: j,
                                                test_case_name: test_case_name,
                                                test_case_description: test_case_description,
                                                glb_folder_id: glb_folder_id,
                                                build_num: build_num,
                                                testset: tpObj.testset,
                                                glb_test_case_id: glb_test_case_id,
                                                glb_test_result_id: glb_test_result_id,
                                                last_run: last_run,
                                                glb_i_length: tpObj.glb_i_length,
                                                glb_j_length: glb_j_length,
                                                i: i,
                                                ws: tpObj.ws,
                                                proj: tpObj.proj,
                                                tags: tagNoTestFolder,
                                                testset_defined_env: tpObj.testset_defined_env
                                            };
                                            kloop(tcObj).then(function (resp1) {
                                                tcObj.stepsArray = stepsArray;
                                                var RallyMethodsWeb = require("./RallyMethodsWeb.js");
                                                var kObj = {
                                                    duration: duration1,
                                                    status: stat,
                                                    response: resp1,
                                                    stepsArray: stepsArray
                                                };
                                                RallyMethodsWeb.noTestCaseFound(tcObj, kObj, function (response) {
                                                    if (response == "step i") callback("step i"); else if (response == "step j") step3(j + 1, done); else callback("callback")
                                                })
                                            })
                                        }
                                    }).catch(function (error) {
                                        console.log("error: " + error);
                                        callback()
                                    })
                                }
                            };
                            loop3(j, done)
                        }
                    };
                    step3(0)
                }).catch(function (error) {
                    callback()
                })
            },

            TestCaseResult: function (tcObj, resp, callback) {
                if (resp.status == undefined || resp.status == "undefined") {
                    if (resp.i == tcObj.glb_i_length - 1 && resp.j == tcObj.glb_j_length - 1) {
                        logger.info("Rally Results Posted\n");
                        console.log("Rally Results Posted\n");
                        rallylog.info("\n-------------------------------------------------\nRally Results Posted\n");
                        callback("callback")
                    } else if (resp.j == tcObj.glb_j_length - 1) {
                        callback("step i")
                    } else {
                        callback("step j")
                    }
                }
                else if (process.env.overwrite_result == "true") {

                    if(typeof tcObj.glb_test_result_id == "undefined")
                    {
                        var opts = {tcObj: tcObj, resp: resp};
                        // console.log("before before update the result: " + JSON.stringify(opts))
                        createTCR(opts, tcObj.ws, tcObj.proj).then(function (resp) {
                            resp.i = i;
                            resp.j = tcObj.j;
                            if (resp.i == tcObj.glb_i_length - 1 && resp.j == tcObj.glb_j_length - 1) {
                                logger.info("Rally Results Posted\n");
                                console.log("Rally Results Posted\n");
                                rallylog.info("\n-------------------------------------------------\nRally Results Posted\n");
                                return callback("callback")
                            } else if (resp.j == tcObj.glb_j_length - 1) {
                                return callback("step i")
                            } else {
                                return callback("step j")
                            }
                        }).catch(function (error) {
                            console.log("error: " + error);
                            callback("callback")
                        })
                    }

                    else {
                        updateTCR(tcObj, resp).then(function (resp) {
                            if (resp.i == tcObj.glb_i_length - 1 && resp.j == tcObj.glb_j_length - 1) {
                                logger.info("Rally Results Posted");
                                console.log("Rally Results Posted");
                                return callback("callback")
                            } else if (resp.j == tcObj.glb_j_length - 1) {
                                callback("step i")
                            } else {
                                callback("step j")
                            }

                        }).catch(function (error) {
                            callback("callback")
                        })
                    }
                }
                else {
                    var opts = {tcObj: tcObj, resp: resp};
                    // console.log("before before update the result: " + JSON.stringify(opts))
                    createTCR(opts, tcObj.ws, tcObj.proj).then(function (resp) {
                        resp.i = i;
                        resp.j = tcObj.j;
                        if (resp.i == tcObj.glb_i_length - 1 && resp.j == tcObj.glb_j_length - 1) {
                            logger.info("Rally Results Posted\n");
                            console.log("Rally Results Posted\n");
                            rallylog.info("\n-------------------------------------------------\nRally Results Posted\n");
                            return callback("callback")
                        } else if (resp.j == tcObj.glb_j_length - 1) {
                            return callback("step i")
                        } else {
                            return callback("step j")
                        }
                    }).catch(function (error) {
                        console.log("error: " + error);
                        callback("callback")
                    })
                }
            }
        }
    };
    module.exports = new RallyMethodsWeb
})
();
